/*
 *  AdORB
 *  Copyright (C) 2006 Victor Ananiev
 *
 *  This file is part of IDLBrowser.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#import <Cocoa/Cocoa.h>
#import "VXMessage.h"
#import "IDLFunction.h"

@interface ResponseSimulator : NSObject 
{
	IBOutlet NSWindow* _window;
	IBOutlet NSTextView* _view;
	int _selectionStart;
	int _selectionLength;
}

+ createSimulator;
+ simulator;
- window;
- (NSMutableData*) response;
- (void) selectAtIndex:(int)index;

@end

@interface VXMessage(ResponseSimulator)
- initWithResponseStream:(IDLOctetStream*)stream;
@end
@interface IDLFunction(ResponseSimulator)
- (NSDictionary*) simulateInvokeWith:(NSDictionary*)args response:(NSMutableData*)response;
@end


extern NSString* SimulatorDidActivate;
extern NSString* SimulatorWillDeactivate;
