//
//  UConnectController.m
//  IDLExplorer
//
//  Created by Victor on 1/19/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "ConnectController.h"
#import "StockWatchController.h"
#import <ADORB/ADORB.h>

@implementation ConnectController


- initWithController:(StockWatchController*)ctrl
{
	if([super initWithNibName:@"Connect" bundle:[NSBundle bundleForClass:[self class]]]){
		_controller = ctrl;
	}
	return self;
}


- (void)viewDidLoad 
{
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	NSString *host = [defaults stringForKey:@"host"];
	NSString *port = [defaults stringForKey:@"port"];
	if(host)
		hostField.text = host;
	if(port)
		portField.text = port;
    [super viewDidLoad];
}


- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload 
{
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (void) connect:sender
{
	NSString *host = hostField.text;
	NSString *port = portField.text;
	if([host length] == 0)
		host = @"localhost";
	if([port length] == 0)
		port = @"15600"; // The default orbd's ORBInitialPort is different

	NSString *nsURL = [NSString stringWithFormat:@"corbaloc:iiop:1.2@%@:%@", host, port];
	CORBAObject *server = nil;
	@try{
		ORB* orb = [ORB defaultORB]; // force to parse IDLs
		[CORBAObject setDefaultConnectTimeout:30.0];
		// connect to naming server
		CORBAObject* ns = [CORBAObject objectWithURL:nsURL];

		// corbaloc provides no information of what interface 'ns' implements
		// so we need to set interface explicitly
		IDLInterface* nsInterface = [orb interfaceNamed:@"CosNaming/NamingContextExt"];
		[ns setInterface:nsInterface];

		NSString* path = @"StockServer";
		server = [ns resolveStr:path];
	}@catch(NSException *e){
		NSLog(@"%@: %@\n", [e name], [e reason]);
	}
	
	if(server){
		NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
		[defaults setObject:host forKey:@"host"];
		[defaults setObject:port forKey:@"port"];
		[_controller setServer:server];
		[self dismissModalViewControllerAnimated:YES];	
	}else{
		
		
	}
}

- (void) cancel:sender
{
	[self dismissModalViewControllerAnimated:YES];
}

- (void)dealloc
{
    [super dealloc];
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
	[textField resignFirstResponder];
	return YES;
}

@end
