/*
 *  AdORB
 *  Copyright (C) 2006 Victor Ananiev
 *
 *  This file is part of ADORB.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#import "IDLValueType.h"
#import "IDLValueClass.h"

enum{
    vt_modifier_none = 0,
    vt_modifier_custom,
    vt_modifier_abstract,
    vt_modifier_truncatable
    };

enum{
    vt_access_private = 0,
    vt_access_public
    };

@class IDLValueClass, IDLEncapsulation;

@interface IDLValueType(Private)

+ (IDLValueType*)valueType;
+ (IDLValueType*)valueTypeWithName:(NSString*)name;
- (void) setTypeDefinition:(IDLDefinition*)type;
- (void) setModifier:(int)modifier;
- (BOOL) addMembers:(NSArray*)nameArray ofType:(IDLDefinition*)type withMode:(int)accessMode;
- (void) setInheritance:(NSArray*)list truncatable:(BOOL)flag;
- (void) setSupportedInterfaces:(NSArray*)list;
- (void) setParentScope:(id<IDLDefinitionScope>)scope;
- (BOOL) isValueBox;
- (IDLValueClass*) classSupport;
- (IDLValueClass*) _classSupport;
+ (void) setLogEnabled:(BOOL)flag;

@end

@interface IDLValueType(_CORBACoding)
- (void) encodeObjectState:obj withCoder:(id<CORBACoder>)coder;
- (void) decodeObjectState:(id*)obj withCoder:(id <CORBADecoder>)coder;
+ _definitionFromCoder:(IDLEncapsulation*)coder tag:(long)tag;
- (void) finishDecodingObject:(id*)obj withObjectCoder:(IDLValueType*)objCoder;
@end
