//
//  ValueView.m
//  IDLExplorer
//
//  Copyright (c) 2003 Victor Ananiev. All rights reserved.
//

#import "ValueView.h"


@implementation ValueView

static NSImage* _image = nil;

- initWithFrame:(NSRect)r
{
    self = [super initWithFrame:r];
    [self setAutoresizingMask:NSViewNotSizable];
    //[self registerForDraggedTypes:types];
    return self;
}

- (void) dealloc
{
    [_object release];
    [super dealloc];
}

- (BOOL) isFlipped
{
    return NO;
}

- (BOOL) acceptsFirstMouse:(NSEvent*)e
{
    return YES;
}

- (BOOL)shouldDelayWindowOrderingForEvent:(NSEvent *)theEvent
{
    return YES;
}

- (void) setObject:anObject
{
    if(anObject != _object){
        [_object release];
        _object = [anObject retain];
        [self setNeedsDisplay:YES];
    }
}

- (void) setObjectValue:anObject
{
    [self setObject:anObject];
}

- object
{
    return _object;
}

- delegate
{
    return delegate;
}

- (void) setDelegate:anObj
{
    delegate = anObj;
}

- (void) drawBackground
{
    NSRect b = [self bounds];
    NSRect clip = [self bounds];
    NSRectEdge sides[] = {NSMinXEdge, NSMaxYEdge, NSMaxXEdge, NSMinYEdge, 
                    NSMinXEdge, NSMaxYEdge, NSMaxXEdge, NSMinYEdge};
    float grays[] = {NSBlack,NSBlack,NSLightGray,NSLightGray,
                    NSDarkGray, NSDarkGray, 0.5, 0.5};
    b = NSDrawTiledRects(b,clip,sides,grays,8);
}

- (void) drawRect:(NSRect)rect
{
    NSRect r = [self bounds];
    [[NSGraphicsContext currentContext]saveGraphicsState];
    [self drawBackground];
    if(_object){
        id image = [NSImage imageNamed:@"value"];
        NSSize s = [image size];
	r = NSInsetRect(r,2,2);
	NSRectClip(r);
        r.origin.x = r.origin.x + floor((r.size.width - s.width)/2);
        r.origin.y = r.origin.y + floor((r.size.height - s.height)/2);
        [image compositeToPoint:r.origin operation:NSCompositeSourceOver];
    }
    [[NSGraphicsContext currentContext]restoreGraphicsState];
}

- (void)  highlight
{
    BOOL isFocus = [NSView focusView] == self;
    NSRect r = [self bounds];
    if(!isFocus)
        [self lockFocus];
    [[NSColor darkGrayColor]set];
    NSFrameRectWithWidth(r, 4.0);
    [[self window] flushWindow];
    [[NSGraphicsContext currentContext]flushGraphics];
    if(!isFocus)
        [self unlockFocus];
}

@end
